-- name: [CS] King Dedede's Dream Friends!
-- description: King Dedede and his pals know a thing or two about stars!\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local globalModName = "King Dedede's Dream Friends!"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_KIRBY_MODEL = smlua_model_util_get_id("kirby_geo") -- Located in "actors"
local E_MKNIGHT_MODEL = smlua_model_util_get_id("metaknight_geo") -- Located in "actors"
local E_WADDLEDEE_MODEL = smlua_model_util_get_id("waddledee_geo") -- Located in "actors"
local E_SUSIE_MODEL = smlua_model_util_get_id("susie_geo") -- Located in "actors"
local E_ADO_MODEL = smlua_model_util_get_id("ado_geo") -- Located in "actors"
local E_MODEL_MARX_MODEL = smlua_model_util_get_id("marx_geo") -- Located in "actors"
local E_DEDEDE_MODEL = smlua_model_util_get_id("dedede_geo") -- Located in "actors"
local E_TARANZA_MODEL = smlua_model_util_get_id("taranza_geo") -- Located in "actors"
local E_CHEFK_MODEL = smlua_model_util_get_id("chefk_geo") -- Located in "actors"
local E_TAC_MODEL = smlua_model_util_get_id("tac_geo") -- Located in "actors"
local E_ROCKY_MODEL = smlua_model_util_get_id("rocky_geo") -- Located in "actors"
local E_KJOE_MODEL = smlua_model_util_get_id("kjoe_geo") -- Located in "actors"
local E_BONKERS_MODEL = smlua_model_util_get_id("bonkers_geo") -- Located in "actors"
local E_DAROACH_MODEL = smlua_model_util_get_id("daroach_geo") -- Located in "actors"
local E_MAGOLOR_MODEL = smlua_model_util_get_id("magolor_geo") -- Located in "actors"
local E_ESCARGOON_MODEL = smlua_model_util_get_id("escargoon_geo") -- Located in "actors"

local TEX_KIRBY_LIFE_ICON = get_texture_info("kirby_icon") -- Located in "textures"
local TEX_MKNIGHT_LIFE_ICON = get_texture_info("mknight_icon") -- Located in "textures"
local TEX_WADDLEDEE_LIFE_ICON = get_texture_info("waddledee_icon") -- Located in "textures"
local TEX_SUSIE_LIFE_ICON = get_texture_info("susie_icon") -- Located in "textures"
local TEX_ADO_LIFE_ICON = get_texture_info("ado_icon") -- Located in "textures"
local TEX_MARX_LIFE_ICON = get_texture_info("marx_icon") -- Located in "textures"
local TEX_DEDEDE_LIFE_ICON = get_texture_info("dedede_icon") -- Located in "textures"
local TEX_TARANZA_LIFE_ICON = get_texture_info("taranza_icon") -- Located in "textures"
local TEX_CHEFK_LIFE_ICON = get_texture_info("chefk_icon") -- Located in "textures"
local TEX_TAC_LIFE_ICON = get_texture_info("tac_icon") -- Located in "textures"
local TEX_ROCKY_LIFE_ICON = get_texture_info("rocky_icon") -- Located in "textures"
local TEX_KJOE_LIFE_ICON = get_texture_info("kjoe_icon") -- Located in "textures"
local TEX_BONKERS_LIFE_ICON = get_texture_info("bonkers_icon") -- Located in "textures"
local TEX_DAROACH_LIFE_ICON = get_texture_info("daroach_icon") -- Located in "textures"
local TEX_MAGOLOR_LIFE_ICON = get_texture_info("magolor_icon") -- Located in "textures"
local TEX_ESCARGOON_LIFE_ICON = get_texture_info("escargoon_icon") -- Located in "textures"

local VOICETABLE_KIRBY = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'kirby_startlevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'kirby_startlevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'kirby_jump1.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'kirby_doublejump.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'kirby_startlevel.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'kirby_grabitem.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'kirby_falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'kirby_doublejump.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'kirby_grabitem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'kirby_getstar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'kirby_throwbowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'kirby_damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'kirby_falling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'kirby_cough.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'kirby_cough.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_DEDEDE = {
	--[CHAR_SOUND_OKEY_DOKEY] = 'I am a super star warrior.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Kick Kirby to the Curb.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'HAH.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Get Ready.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Gotcha.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'HAH.ogg', 'HAH.ogg', 'Yo.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Get Ready.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Outta My Way.ogg', 'Comin Atcha.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'AHHH.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Look at that Charisma.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Yo.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'AHHH.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'DEDEDEFall.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Comin Atcha.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'HMM.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'I am a super star warrior.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Kick Kirby to the Curb.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Suffering.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'AHH Help Me.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'UGGGH.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'cough1.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'cough2.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Surely You Jestin.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Holy Calamari.ogg' -- Booted out of level
}

local VOICETABLE_MKNIGHT = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'MK_GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'MK_GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'MK_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'MK_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'MK_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MK_TripleJump1.ogg', 'MK_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'MK_Damaged.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'MK_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'MK_GrabLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'MK_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'MK_TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'MK_GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'MK_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'MK_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'MK_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'MK_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'MK_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'MK_Tired.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'MK_Tired.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'MK_LeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_WADDLEDEE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Jump2.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Jump2.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Jump2.ogg', 'Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'WD_TripleJump1.ogg', 'WD_TripleJump1.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'GrabLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'DeeFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Punch2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Jump2.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Bonk.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Burned.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_SUSIE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Susie_GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Susie_GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Susie_LongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Susie_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Susie_GetStar.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Susie_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Susie_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_ADO = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_MARX = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Marx_StartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Marx_StartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Marx_TripleJump1.ogg', 'Marx_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Marx_StartLevel.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Marx_Laugh.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Marx_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Marx_Laugh.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Marx_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Marx_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Marx_Burned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Marx_Laugh.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Marx_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Marx_Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Tired.ogg' -- Booted out of level
}

local VOICETABLE_TARANZA = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_CHEFK = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'KAW_StartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'KAW_StartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'KAW_GetStar.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'KAW_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'KAW_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'KAW_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'KAW_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'KAW_LeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_TAC = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_ROCKY = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_KJOE = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_BONKERS = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Ado_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Ado_Damaged.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local VOICETABLE_DAROACH = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'DAR_Jump4.ogg', 'DAR_DoubleJump.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Ado_TripleJump2.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'DAR_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'DAR_Longjump.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'DAR_Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Silent.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'DAR_Damaged.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Ado_Jump2.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'DAR_Damaged.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'DAR_Damaged.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'DAR_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'DAR_Jump4.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'DAR_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'DAR_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'DAR_Damaged.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'DAR_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'DAR_LeaveLevel.ogg' -- Booted out of level
}

local VOICETABLE_MAGOLOR = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'Ado_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Ado_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'MAG_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MAG_TripleJump1.ogg', 'Ado_TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Ado_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Ado_LevelStart.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Ado_Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'MAG_GrabItem.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Silent.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Ado_TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'MAG_GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Ado_LevelStart.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'Ado_Punch2.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'MAG_Hurt.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'MAG_Hurt.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Ado_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Ado_Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Damaged.ogg' -- Booted out of level
}

local CAPTABLE_MARX = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local VOICETABLE_ESCARGOON = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'ESC_LevelStart.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'ESC_LevelStart.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Ado_Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Ado_Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Ado_Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ado_Jump1.ogg', 'Ado_Jump2.ogg', 'Ado_Jump3.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'Ado_DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'ESC_TripleJump1.ogg', 'ESC_Laugh.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'ESC_Bonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Ado_Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'ESC_Bonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'ESC_Bonk.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Ado_Jump2.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'ESC_Falling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'ESC_TripleJump1.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'ESC_Bonk.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'ESC_GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'ESC_ThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'ESC_Damaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'ESC_Falling.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Ado_Tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Ado_Tired.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Ado_Tired.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'ESC_Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'ESC_Drowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'ESC_LeaveLevel.ogg' -- Booted out of level
}

local CAPTABLE_DAROACH = {
    normal = smlua_model_util_get_id("daroachhat_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_ESCARGOON = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_BONKERS = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_KJOE = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_CHEFK = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_WADDLEDEE = {
    normal = smlua_model_util_get_id("deenormal_geo"),
    wing = smlua_model_util_get_id("deewing_geo"),
    metal = smlua_model_util_get_id("deemetal_geo"),
}

local CAPTABLE_DEDEDE = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("dedede_metal_cap_geo"),
}

local CAPTABLE_ADO = {
    normal = smlua_model_util_get_id("adovanish_geo"),
    wing = smlua_model_util_get_id("adowing_geo"),
    metal = smlua_model_util_get_id("adometal_geo"),
}

local CAPTABLE_SUSIE = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_KIRBY = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_MKNIGHT = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_TARANZA = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_TAC = {
    normal = smlua_model_util_get_id("tacbag_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_ROCKY = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local CAPTABLE_MAGOLOR = {
    normal = smlua_model_util_get_id("KDNormal_geo"),
    wing = smlua_model_util_get_id("KDWing_geo"),
    metal = smlua_model_util_get_id("KDMetal_geo"),
}

local PALETTE_KIRBY = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "CB0800",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FFA1D6",
    [CAP]    = "FFA1D6",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_DEDEDE = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "FF0007",
    [GLOVES] = "ffffff",
    [SHOES]  = "FFA800",
    [HAIR]   = "FFA800",
    [SKIN]   = "0098FF",
    [CAP]    = "FF0007",
	[EMBLEM] = "FFA800",
}

local PALETTE_MKNIGHT = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FF91FF",
    [GLOVES] = "91928D",
    [SHOES]  = "FF40BD",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "0006CB",
    [CAP]    = "FFFFFF",
    [EMBLEM]  = "8A00DC",
}

local PALETTE_WADDLEDEE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FF4B2F",
    [CAP]    = "183094",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_SUSIE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FE55FF",
    [SKIN]   = "FFFFFF",
    [CAP]    = "FE55FF",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_ADO = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "24D974",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "723F31",
    [HAIR]   = "000000",
    [SKIN]   = "FEC179",
    [CAP]    = "FF2300",
    [EMBLEM]  = "1FA7FF",
}

local PALETTE_MARX = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "C22242",
    [GLOVES] = "ffffff",
    [SHOES]  = "721600",
    [HAIR]   = "ffffff",
    [SKIN]   = "CF66C0",
    [CAP]    = "FF0004",
	[EMBLEM] = "4843FF"
}

local PALETTE_TARANZA = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "0B6045",
    [GLOVES] = "FFF4EC",
    [SHOES]  = "ffffff",
    [HAIR]   = "8F8F8E",
    [SKIN]   = "0B6045",
    [CAP]    = "FF0017",
	[EMBLEM] = "D4833E"
}

local PALETTE_CHEFK = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FF3F6F",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FF8B53",
    [CAP]    = "FFFFFF",
    [EMBLEM]  = "00A0FF",
}

local PALETTE_TAC = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "BE8231",
    [SHOES]  = "FF7A25",
    [HAIR]   = "D7FF00",
    [SKIN]   = "004804",
    [CAP]    = "009B09",
    [EMBLEM]  = "04A700",
}

local PALETTE_ROCKY = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFC872",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "C45050",
    [CAP]    = "C45050",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_KJOE = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFAC58",
    [SKIN]   = "000987",
    [CAP]    = "CFD9E1",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_BONKERS = {
    [PANTS]  = "030FFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "540692",
    [CAP]    = "540692",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_DAROACH = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FF0004",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "787878",
    [SKIN]   = "4B4B4B",
    [CAP]    = "FF0004",
    [EMBLEM]  = "FF9E00",
}

local PALETTE_MAGOLOR = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "CECECE",
    [GLOVES] = "F2B70E",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "4B8EFF",
    [SKIN]   = "FFFFFF",
    [CAP]    = "4B8EFF",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_ESCARGOON = {
    [PANTS]  = "40B788",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "88A477",
    [SKIN]   = "DFC4E6",
    [CAP]    = "40B788",
    [EMBLEM]  = "FFFFFF",
}

local CSloaded = false
local function on_character_select_load()
	
	CT_DEDEDE = _G.charSelect.character_add("King Dedede", {"The King of Dreamland is here...to help?", "Model from Kirby 64"}, "Garrulous64", {r = 255, g = 0, b = 0}, E_DEDEDE_MODEL, CT_DEDEDE, TEX_DEDEDE_LIFE_ICON)
    _G.charSelect.character_add_caps(E_DEDEDE_MODEL, CAPTABLE_DEDEDE)
    _G.charSelect.character_add_voice(E_DEDEDE_MODEL, VOICETABLE_DEDEDE)
    _G.charSelect.character_add_palette_preset(E_DEDEDE_MODEL, PALETTE_DEDEDE)
	
	CT_ESCARGOON = _G.charSelect.character_add("Escargoon", {"Royal right hand snail", "Custom Model by: SAB64"}, "Garrulous64", {r = 223, g = 196, b = 230}, E_ESCARGOON_MODEL, CT_ESCARGOON, TEX_ESCARGOON_LIFE_ICON)
    _G.charSelect.character_add_caps(E_ESCARGOON_MODEL, CAPTABLE_ESCARGOON)
    _G.charSelect.character_add_voice(E_ESCARGOON_MODEL, VOICETABLE_ESCARGOON)
    _G.charSelect.character_add_palette_preset(E_ESCARGOON_MODEL, PALETTE_ESCARGOON)

    CT_KIRBY = _G.charSelect.character_add("Kirby", {"Star Warrior of Planet Popstar!", ""}, "Garrulous64", {r = 255, g = 192, b = 203}, E_KIRBY_MODEL, CT_KIRBY, TEX_KIRBY_LIFE_ICON)
    _G.charSelect.character_add_voice(E_KIRBY_MODEL, VOICETABLE_KIRBY)
    _G.charSelect.character_add_palette_preset(E_KIRBY_MODEL, PALETTE_KIRBY)
	_G.charSelect.character_add_caps(E_KIRBY_MODEL, CAPTABLE_KIRBY)

    CT_MKNIGHT = _G.charSelect.character_add("Meta Knight", {"The Masked Mystery.", ""}, "Garrulous64", {r = 0, g = 0, b = 255}, E_MKNIGHT_MODEL, CT_MKNIGHT, TEX_MKNIGHT_LIFE_ICON)
    _G.charSelect.character_add_voice(E_MKNIGHT_MODEL, VOICETABLE_MKNIGHT)
    _G.charSelect.character_add_palette_preset(E_MKNIGHT_MODEL, PALETTE_MKNIGHT)
	_G.charSelect.character_add_caps(E_MKNIGHT_MODEL, CAPTABLE_MKNIGHT)

    CT_WADDLEDEE = _G.charSelect.character_add("Waddle Dee", {"The King's Right Hand.", ""}, "Garrulous64", {r = 150, g = 75, b = 0}, E_WADDLEDEE_MODEL, CT_WADDLEDEE, TEX_WADDLEDEE_LIFE_ICON)
    _G.charSelect.character_add_voice(E_WADDLEDEE_MODEL, VOICETABLE_WADDLEDEE)
	_G.charSelect.character_add_caps(E_WADDLEDEE_MODEL, CAPTABLE_WADDLEDEE)
    _G.charSelect.character_add_palette_preset(E_WADDLEDEE_MODEL, PALETTE_WADDLEDEE)
	
	CT_ADO = _G.charSelect.character_add("Adeleine", {"The Lively Painter.", ""}, "Garrulous64", {r = 45, g = 255, b = 220}, E_ADO_MODEL, CT_ADO, TEX_ADO_LIFE_ICON)
    _G.charSelect.character_add_voice(E_ADO_MODEL, VOICETABLE_ADO)
    _G.charSelect.character_add_palette_preset(E_ADO_MODEL, PALETTE_ADO)
	_G.charSelect.character_add_caps(E_ADO_MODEL, CAPTABLE_ADO)
	
	CT_DAROACH = _G.charSelect.character_add("Daroach", {"Squeak Squad's BIG CHEESE", ""}, "Garrulous64", {r = 255, g = 0, b = 0}, E_DAROACH_MODEL, CT_DAROACH, TEX_DAROACH_LIFE_ICON)
    _G.charSelect.character_add_caps(E_DAROACH_MODEL, CAPTABLE_DAROACH)
    _G.charSelect.character_add_voice(E_DAROACH_MODEL, VOICETABLE_DAROACH)
    _G.charSelect.character_add_palette_preset(E_DAROACH_MODEL, PALETTE_DAROACH)
	
	CT_MAGOLOR = _G.charSelect.character_add("Magolor", {"Lor Starcutter's traiterous technician", ""}, "Garrulous64", {r = 0, g = 150, b = 255}, E_MAGOLOR_MODEL, CT_MAGOLOR, TEX_MAGOLOR_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MAGOLOR_MODEL, CAPTABLE_MAGOLOR)
    _G.charSelect.character_add_voice(E_MAGOLOR_MODEL, VOICETABLE_MAGOLOR)
    _G.charSelect.character_add_palette_preset(E_MAGOLOR_MODEL, PALETTE_MAGOLOR)
	
	CT_TARANZA = _G.charSelect.character_add("Taranza", {"Lovesick Spider of the Dreamstalk", ""}, "Garrulous64", {r = 239, g = 255, b = 0}, E_TARANZA_MODEL, CT_TARANZA, TEX_TARANZA_LIFE_ICON)
    _G.charSelect.character_add_caps(E_TARANZA_MODEL, CAPTABLE_TARANZA)
    _G.charSelect.character_add_voice(E_TARANZA_MODEL, VOICETABLE_TARANZA)
    _G.charSelect.character_add_palette_preset(E_TARANZA_MODEL, PALETTE_TARANZA)
	
	CT_SUSIE = _G.charSelect.character_add("Susie Haltmann", {"Heir to the Haltmann Fortune.", ""}, "Garrulous64", {r = 255, g = 192, b = 203}, E_SUSIE_MODEL, CT_SUSIE, TEX_SUSIE_LIFE_ICON)
    _G.charSelect.character_add_voice(E_SUSIE_MODEL, VOICETABLE_SUSIE)
    _G.charSelect.character_add_palette_preset(E_SUSIE_MODEL, PALETTE_SUSIE)
	_G.charSelect.character_add_caps(E_SUSIE_MODEL, CAPTABLE_SUSIE)
	
	CT_CHEFK = _G.charSelect.character_add("Chef Kawasaki", {"Your Dream Chef!", ""}, "Garrulous64", {r = 255, g = 100, b = 0}, E_CHEFK_MODEL, CT_CHEFK, TEX_CHEFK_LIFE_ICON)
    _G.charSelect.character_add_caps(E_CHEFK_MODEL, CAPTABLE_CHEFK)
    _G.charSelect.character_add_voice(E_CHEFK_MODEL, VOICETABLE_CHEFK)
    _G.charSelect.character_add_palette_preset(E_CHEFK_MODEL, PALETTE_CHEFK)
	
	CT_BONKERS = _G.charSelect.character_add("Bonkers", {"Big Monkey", ""}, "Garrulous64", {r = 150, g = 0, b = 255}, E_BONKERS_MODEL, CT_BONKERS, TEX_BONKERS_LIFE_ICON)
    _G.charSelect.character_add_caps(E_BONKERS_MODEL, CAPTABLE_BONKERS)
    _G.charSelect.character_add_voice(E_BONKERS_MODEL, VOICETABLE_BONKERS)
    _G.charSelect.character_add_palette_preset(E_BONKERS_MODEL, PALETTE_BONKERS)
	
	CT_KJOE = _G.charSelect.character_add("Knuckle Joe", {"Punch-happy Star Warrior", ""}, "Garrulous64", {r = 0, g = 0, b = 255}, E_KJOE_MODEL, CT_KJOE, TEX_KJOE_LIFE_ICON)
    _G.charSelect.character_add_caps(E_KJOE_MODEL, CAPTABLE_KJOE)
    _G.charSelect.character_add_voice(E_KJOE_MODEL, VOICETABLE_KJOE)
    _G.charSelect.character_add_palette_preset(E_KJOE_MODEL, PALETTE_KJOE)
	
	CT_TAC = _G.charSelect.character_add("Tac", {"Stop, theif!", ""}, "Garrulous64", {r = 0, g = 100, b = 0}, E_TAC_MODEL, CT_TAC, TEX_TAC_LIFE_ICON)
    _G.charSelect.character_add_caps(E_TAC_MODEL, CAPTABLE_TAC)
    _G.charSelect.character_add_voice(E_TAC_MODEL, VOICETABLE_TAC)
    _G.charSelect.character_add_palette_preset(E_TAC_MODEL, PALETTE_TAC)
	
	CT_ROCKY = _G.charSelect.character_add("Rocky", {"Friendship, on the rocks!", ""}, "Garrulous64", {r = 255, g = 40, b = 40}, E_ROCKY_MODEL, CT_ROCKY, TEX_ROCKY_LIFE_ICON)
    _G.charSelect.character_add_caps(E_ROCKY_MODEL, CAPTABLE_ROCKY)
    _G.charSelect.character_add_voice(E_ROCKY_MODEL, VOICETABLE_ROCKY)
    _G.charSelect.character_add_palette_preset(E_ROCKY_MODEL, PALETTE_ROCKY)
	
	CT_MARX = _G.charSelect.character_add("Marx", {"Mad, Malevolent Jester", ""}, "Garrulous64", {r = 171, g = 45, b = 255}, E_MODEL_MARX_MODEL, CT_MARX, TEX_MARX_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_MARX_MODEL, CAPTABLE_MARX)
    _G.charSelect.character_add_voice(E_MODEL_MARX_MODEL, VOICETABLE_MARX)
    _G.charSelect.character_add_palette_preset(E_MODEL_MARX_MODEL, PALETTE_MARX)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_KIRBY then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SUSIE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WADDLEDEE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MKNIGHT then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ADO then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MARX then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TARANZA then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHEFK then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TAC then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ROCKY then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_KJOE then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BONKERS then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DAROACH then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MAGOLOR then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ESCARGOON then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_KIRBY then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_WADDLEDEE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MKNIGHT then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SUSIE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ADO then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MARX then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DEDEDE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TARANZA then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_CHEFK then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_TAC then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ROCKY then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_KJOE then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_BONKERS then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_DAROACH then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_MAGOLOR then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_ESCARGOON then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)